<?php

$response = array();


function init_experiment($name) {
	
	global $db;
		
	$db_behavior = $name . "_behavior";
	$db_payoff = $name . "_payoff";
	$db_log = $name . "_log";
	$db_final = $name . "_final";
	$db_round = $name . "_round";
		
	$table_behavior = "CREATE TABLE IF NOT EXISTS $db_behavior ( `ID` INT(10) NOT NULL AUTO_INCREMENT, `date` VARCHAR(20) , `subject` INT(5) , `group` INT(5) , `team` INT(5) , `stage` INT(5) , `round` INT(5) , `part` INT(5) , `type` VARCHAR(200) , `treatment` VARCHAR(200) , `response` TEXT , `RT` DOUBLE , `comment` TEXT , PRIMARY KEY (`ID`)) ENGINE = InnoDB";
	$table_payoff   = "CREATE TABLE IF NOT EXISTS $db_payoff   ( `ID` INT(10) NOT NULL AUTO_INCREMENT, `date` VARCHAR(20) , `subject` INT(5) , `group` INT(5) , `team` INT(5) , `stage` INT(5) , `round` INT(5) , `part` INT(5) , `type` VARCHAR(200) , `treatment` VARCHAR(200) , `payoff` TEXT   , `RT` DOUBLE , `comment` TEXT , PRIMARY KEY (`ID`)) ENGINE = InnoDB";
	$table_log      = "CREATE TABLE IF NOT EXISTS $db_log      ( `ID` INT(10) NOT NULL AUTO_INCREMENT, `date` VARCHAR(20) , `subject` INT(5) , `group` INT(5) , `team` INT(5) , `stage` INT(5) , `round` INT(5) , `part` INT(5) , `type` VARCHAR(200) , `treatment` VARCHAR(200) , `log` TEXT      , `RT` DOUBLE , `comment` TEXT , PRIMARY KEY (`ID`)) ENGINE = InnoDB";
	$table_final    = "CREATE TABLE IF NOT EXISTS $db_final    ( `ID` INT(10) NOT NULL AUTO_INCREMENT, `date` VARCHAR(20) , `subject` INT(5) , `group` INT(5) , `team` INT(5) , `stage` INT(5) , `round` INT(5) , `part` INT(5) , `type` VARCHAR(200) , `treatment` VARCHAR(200) , `final` TEXT    , `RT` DOUBLE , `comment` TEXT , PRIMARY KEY (`ID`)) ENGINE = InnoDB";
	$table_round    = "CREATE TABLE IF NOT EXISTS $db_round    ( `ID` INT(10) NOT NULL AUTO_INCREMENT, `subject` INT(5) , `group` INT(5) , `team` INT(5) , `stage` INT(5) , `round` INT(5) , `part` INT(5) , `initialized` BOOLEAN , PRIMARY KEY (`ID`)) ENGINE = InnoDB";
	
	$db -> beginTransaction();
	
	$query = $db -> prepare($table_behavior);
	$query -> execute();
	
	$query = $db -> prepare($table_payoff);
	$query -> execute();
	
	$query = $db -> prepare($table_log);
	$query -> execute();
	
	$query = $db -> prepare($table_final);
	$query -> execute();
	
	$query = $db -> prepare($table_round);
	$query -> execute();
	
	$db -> commit();
}

function init_group($data) {
	
	global $response, $db, $subjects, $name, $teams;
	$table = $name . "_round";
	
	$db -> beginTransaction();
		
	foreach($data as $key=>$group) {
		
		for($subject = 1; $subject <= $subjects; $subject++) {
						
			if(isset($teams)) {	 $team = $teams[$subject-1];	}
			else {	$team = 1;	}
			if($team == NULL) {  $response["warning"][] = __FUNCTION__ . '[' . strval($group) . ']: subject ' . $subject . ' (group ' . $group . ') team undefined - set to NULL';	}
			
            $response["warning"][] = __FUNCTION__ . $team . 'xxx';
            
			$query = $db -> query("SELECT count(*) FROM $table WHERE `group` = $group AND subject = $subject");
			$rows = $query -> fetchColumn();
										
			if($rows == 0) {
				
				$query = $db -> prepare("INSERT INTO $table VALUES (DEFAULT, :subject, :group, :team, :stage, :round, :part, :initialized)");
				$query -> execute(array(':subject' => $subject, ':group' => $group, ':team' => $team, ':stage' => 1, ':round' => 1, ':part' => 1, ':initialized' => 0));
				
				//$response["ID"][$subject] =  $db->lastInsertId();
				
			}
			else {	
				
				//$query = $db -> prepare("SELECT ID FROM $table WHERE subject = :subject AND `group` = :group");
				//$query -> execute(array(':subject' => $subject, ':group' => $group));
	            //
				//$row = $query -> fetch(PDO::FETCH_ASSOC);
				//$response["ID"][$subject] =  $row['ID'];						  
				
				$response["warning"][] = __FUNCTION__ . '[' . strval($group) . ']: subject ' . $subject . ' (group ' . $group . ') already in database';	
			
			}
		}
	}
	
	$db -> commit();
}

function init_subject($data) {
	
	global $response, $db, $name;
	$table = $name . "_round";
	
	$db -> beginTransaction();
	
	foreach($data as $key=>$item) {
		
		$query = $db -> prepare("UPDATE $table SET initialized = 1 WHERE subject = :subject AND `group` = :group");
		$query -> execute(array(':subject' => $item['subject'], ':group' => $item['group']));	
		
		$query = $db -> prepare("SELECT ID FROM $table WHERE subject = :subject AND `group` = :group");
		$query -> execute(array(':subject' => $item['subject'], ':group' => $item['group']));
        
		$row = $query -> fetch(PDO::FETCH_ASSOC);
		$response["ID"][$item['group']][$item['subject']] =  $row['ID'];
		
	}
	
	$db -> commit();	
}


try {
	
	$parameters = simplexml_load_file('../../content/global parameters.xml');
	$name = $parameters->name;
	$subjects = $parameters->subjects;  	
		
	include("database.php");
	$input = $_REQUEST['options'];
       
    if(isset($input['teams'])) {    $teams = $input['teams'];  }	
	if(isset($input['experiment'])) { init_experiment($name); }
	if(isset($input['group'])) { init_group($input['group']); }
	if(isset($input['subject'])) { init_subject($input['subject']); }
		
		
	echo json_encode($response);
	$db = null;
	
}


catch(PDOException $e) {
	
	$response["error"] = $e -> getMessage();
	echo json_encode($response);
	exit;
}
catch(exception $e) {

	$response["error"] = $e -> getMessage();
	echo json_encode($response);
	exit;
}


?>