<?php

$response = array();

function get_parameters($ID) {
	
	global $response, $db, $name;
	$table = $name . "_round";
	
	if(!isset($ID)) { $response["warning"][] = __FUNCTION__ . ': ID not transferred - only returning global parameters';  }
	else {
		
		$query = $db -> prepare("SELECT subject,`group`,team,stage,round,part,initialized FROM $table WHERE ID = :ID");
		$query -> execute(array(':ID' => $ID));
		
		$output = $query -> fetch(PDO::FETCH_ASSOC);
		
		if(file_exists("../../content/local parameters $ID.xml")) { 
			$local_parameters = simplexml_load_file("../../content/local parameters $ID.xml", 'SimpleXMLElement', LIBXML_NOCDATA);
		}
		else {
			$response["warning"][] = __FUNCTION__ . ": Unable to read parameters for ID $ID";
			$local_parameters = FALSE;
		}		
		
		if($local_parameters == FALSE)   $response["warning"][] = __FUNCTION__ . ": no local parameters found for ID $ID";
		else  $output = array_merge((array) $output, (array) $local_parameters);
		
		$output = array_merge((array) $output, (array) $local_parameters);			
		return $output;
	}
}


try {
	
	$parameters = simplexml_load_file('../../content/global parameters.xml', 'SimpleXMLElement', LIBXML_NOCDATA);
	$name = $parameters->name;
					
	include("database.php");
	
	$ID = $_REQUEST['ID'];
	$state = get_parameters($ID);
	
	$requested_parameters = $_REQUEST['parameters'];
	$parameters = array_merge((array) $parameters);
	
	foreach($requested_parameters as $param) {
		
		if(isset($state[$param]))  $response['parameters'][$param] =  $state[$param];  		
		else if(isset($parameters[$param]))  $response['parameters'][$param] = $parameters[$param]; 
	}
	
	
	echo json_encode($response);
	$db = null;	
}


catch(PDOException $e) {
	
	$response["error"] = $e -> getMessage();
	echo json_encode($response);
	exit;
}
catch(exception $e) {

	$response["error"] = $e -> getMessage();
	echo json_encode($response);
	exit;
}

?>