<?php

$response = array();
$date = date('Y_m_d_G_i_s');


function read_behavior($data) {
	
	global $response, $date, $db, $name;
	$table = $name . "_behavior";
	
	$db -> beginTransaction();
	
	foreach($data as $key=>$item) {
						
		if(isset($item['ID'])) {
						
			$status = get_parameters($item['ID']);
			$item['subject'] = $status['subject'];
			$item['group']   = $status['group'];
			if(!isset($item['team']))    $item['team']    = $status['team'];
			if(!isset($item['stage']))   $item['stage']   = $status['stage'];
			if(!isset($item['round']))   $item['round']   = $status['round'];
			if(!isset($item['part']))    $item['part']    = $status['part'];
		}
				
		$content = array(
		    ":subject"   => $item['subject'],
		    ":group"     => $item['group'],
		    ":team"      => $item['team'],
			":stage"     => $item['stage'],
			":round"     => $item['round'],
			":part"      => $item['part'],
			":type"      => $item['type'],
			":treatment" => $item['treatment'],
			":response"  => $item['response'],
			":RT"        => $item['RT'],
			":comment"   => $item['comment']
		);
		$content = array_filter($content);
		
		$query = "SELECT * FROM $table WHERE ";
		foreach($content as $key=>$value) {   $query = $query . str_replace(':', '`', $key) . '` = ' . $key . ' AND ';	}
		$query = $query . "ORDER BY `group`, subject, ID";
				
		$query = str_replace('AND ORDER', 'ORDER', $query);
						
		$query = $db -> prepare($query);
		$query -> execute($content);
				
				
		while($row = $query -> fetch(PDO::FETCH_ASSOC)) {
						
			$content = array(
			    "stage"   => $row['stage'],
			    "round"   => $row['round'],
			    "part"    => $row['part'],
				"team"    => $row['team'],
				"type"      => $row['type'],
				"treatment" => $row['treatment'],
				"response"  => $row['response'],
				"comment"  => $row['comment'],
				"RT" 	    => $row['RT']
			);
			
			if(isset($item['ID'])) {
				
				$content['group'] = $row['group'];
				$content['subject'] = $row['subject'];
				$response['behavior'][$item['ID']][] = $content;
			}						
			else  $response['behavior'][$row['group']][$row['subject']][] = $content;
		}					
	}
	
	$db -> commit();	
}

function read_status($data) {
	
	global $response, $db, $name;
	$table = $name . "_round";
	
	$db -> beginTransaction();
	
	foreach($data as $key=>$item) {
						
		if(isset($item['ID'])) {
						
			$status = get_parameters($item['ID']);
			$item['subject'] = $status['subject'];
			$item['group']   = $status['group'];
		}
				
		$content = array(
		    ":subject"   => $item['subject'],
		    ":group"     => $item['group'],
		    ":team"      => $item['team'],
			":stage"     => $item['stage'],
			":round"     => $item['round'],
			":part"      => $item['part'],
			":initialized"  => $item['initialized']
		);
		$content = array_filter($content);
		
		$query = "SELECT * FROM $table WHERE ";
		foreach($content as $key=>$value) {   $query = $query . str_replace(':', '`', $key) . '` = ' . $key . ' AND ';	}
		$query = $query . "ORDER BY `group`, subject, ID";
				
		$query = str_replace('AND ORDER', 'ORDER', $query);
						
		$query = $db -> prepare($query);
		$query -> execute($content);
				
				
		while($row = $query -> fetch(PDO::FETCH_ASSOC)) {
						
			$content = array(
			    "stage"   => $row['stage'],
			    "round"   => $row['round'],
			    "part"    => $row['part'],
				"team"    => $row['team'],
				"initialized" => $row['initialized']
			);
			
			if(isset($item['ID'])) {
				
				$content['group'] = $row['group'];
				$content['subject'] = $row['subject'];
				$response['status'][$item['ID']][] = $content;
			}						
			else  $response['status'][$row['group']][$row['subject']] = $content;
		}					
	}
	
	$db -> commit();	
}

function read_payoff($data) {
	
	global $response, $date, $db, $name;
	$table = $name . "_payoff";
	
	$db -> beginTransaction();
	
	foreach($data as $key=>$item) {
		
		if(isset($item['ID'])) {
			
			$status = get_parameters($item['ID']);
			$item['subject'] = $status['subject'];
			$item['group']   = $status['group'];
			if(!isset($item['team']))    $item['team']    = $status['team'];
			if(!isset($item['stage']))   $item['stage']   = $status['stage'];
			if(!isset($item['round']))   $item['round']   = $status['round'];
			if(!isset($item['part']))    $item['part']    = $status['part'];
		}
		
		$content = array(
		    ":subject"   => $item['subject'],
		    ":group"     => $item['group'],
		    ":team"      => $item['team'],
			":stage"     => $item['stage'],
			":round"     => $item['round'],
			":part"      => $item['part'],
			":type"      => $item['type'],
			":treatment" => $item['treatment'],
			":payoff"    => $item['payoff'],
			":RT"        => $item['RT'],
			":comment"   => $item['comment']
		);
		$content = array_filter($content);
		
		if($item['sum'] == 'true') 	{
			$query = "SELECT SUM(payoff), `group`, subject FROM $table WHERE `subject` = :subject AND `group` = :group ";
			$content = array(
			    ":subject"   => $item['subject'],
			    ":group"     => $item['group']
			);
		}
		else {
			$query = "SELECT * FROM $table WHERE ";
			foreach($content as $key=>$value) {   $query = $query . str_replace(':', '`', $key) . '` = ' . $key . ' AND ';	}
		}
		
		$query = $query . "ORDER BY `group`, subject, ID";
		$query = str_replace('AND ORDER', 'ORDER', $query);
		
		//$response['warning'][] = $query;
								
		$query = $db -> prepare($query);
		$query -> execute($content);
				
		while($row = $query -> fetch(PDO::FETCH_ASSOC)) {
			
			if($item['sum'] == 'true') {
				
				$content = $row['SUM(payoff)'];					
			}
			else {
								
				$content = array(
				    "stage"   => $row['stage'],
				    "round"   => $row['round'],
				    "part"    => $row['part'],
					"team"    => $row['team'],
					"type"      => $row['type'],
					"treatment" => $row['treatment'],
					"payoff"    => $row['payoff'],
					"RT" 	    => $row['RT']
				);
			}
						
			if(isset($item['ID'])) {
								
			    #$content['group'] = $row['group'];
				#$content['subject'] = $row['subject'];
				$content['payoff'] = $content;
				$response['payoff'][$item['ID']][] = $content;								
			}  
			else   	$response['payoff'][$row['group']][$row['subject']][] = $content;
		}					
	}
	
	$db -> commit();	
}

function read_log($data) {
	
	global $response, $date, $db, $name;
	$table = $name . "_log";
	
	$db -> beginTransaction();
	
	foreach($data as $key=>$item) {
		
		if(isset($item['ID'])) {
			
			$status = get_parameters($item['ID']);
			$item['subject'] = $status['subject'];
			$item['group']   = $status['group'];
			if(!isset($item['team']))    $item['team']    = $status['team'];
			if(!isset($item['stage']))   $item['stage']   = $status['stage'];
			if(!isset($item['round']))   $item['round']   = $status['round'];
			if(!isset($item['part']))    $item['part']    = $status['part'];
		}
		
		$content = array(
		    ":subject"   => $item['subject'],
		    ":group"     => $item['group'],
		    ":team"      => $item['team'],
			":stage"     => $item['stage'],
			":round"     => $item['round'],
			":part"      => $item['part'],
			":type"      => $item['type'],
			":treatment" => $item['treatment'],
			":log"       => $item['log'],
			":RT"        => $item['RT'],
			":comment"   => $item['comment']
		);
		$content = array_filter($content);
		
		$query = "SELECT * FROM $table WHERE ";
		foreach($content as $key=>$value) {   $query = $query . str_replace(':', '`', $key) . '` = ' . $key . ' AND ';	}
		$query = $query . "ORDER BY `group`, subject, ID";
		$query = str_replace('AND ORDER', 'ORDER', $query);
				
		$query = $db -> prepare($query);
		$query -> execute($content);
		
		while($row = $query -> fetch(PDO::FETCH_ASSOC)) {
						
			$content = array(
			    "stage"   => $row['stage'],
			    "round"   => $row['round'],
			    "part"    => $row['part'],
				"team"    => $row['team'],
				"type"      => $row['type'],
				"treatment" => $row['treatment'],
				"log"       => $row['log'],
				"RT" 	    => $row['RT'],
                "comment"   => $row['comment']
			);
			
			if(isset($item['ID'])) {
				
				$content['group'] = $row['group'];
				$content['subject'] = $row['subject'];
				$response['log'][$item['ID']][] = $content;				
			}  
			else   	$response['log'][$row['group']][$row['subject']][] = $content;
		}					
	}
	
	$db -> commit();	
}

function read_final($data) {
	
	global $response, $date, $db, $name;
	$table = $name . "_final";
	
	$db -> beginTransaction();
	
	foreach($data as $key=>$item) {
				
		if(isset($item['ID'])) {
						
			$status = get_parameters($item['ID']);
			$item['subject'] = $status['subject'];
			$item['group']   = $status['group'];
			if(!isset($item['team']))    $item['team']    = $status['team'];
			if(!isset($item['stage']))   $item['stage']   = $status['stage'];
			if(!isset($item['round']))   $item['round']   = $status['round'];
			if(!isset($item['part']))    $item['part']    = $status['part'];
		}
		
		$content = array(
		    ":subject"   => $item['subject'],
		    ":group"     => $item['group'],
		    ":team"      => $item['team'],
			":stage"     => $item['stage'],
			":round"     => $item['round'],
			":part"      => $item['part'],
			":type"      => $item['type'],
			":treatment" => $item['treatment'],
			":final"     => $item['final'],
			":RT"        => $item['RT'],
			":comment"   => $item['comment']
		);
		$content = array_filter($content);
		
		$query = "SELECT * FROM $table WHERE ";
		foreach($content as $key=>$value) {   $query = $query . str_replace(':', '`', $key) . '` = ' . $key . ' AND ';	}
		$query = $query . "ORDER BY `group`, subject, ID";
		$query = str_replace('AND ORDER', 'ORDER', $query);
				
		$query = $db -> prepare($query);
		$query -> execute($content);
		
		while($row = $query -> fetch(PDO::FETCH_ASSOC)) {
						
			$content = array(
			    "stage"   => $row['stage'],
			    "round"   => $row['round'],
			    "part"    => $row['part'],
				"team"    => $row['team'],
				"type"      => $row['type'],
				"treatment" => $row['treatment'],
				"final"     => $row['final'],
				"RT" 	    => $row['RT']
			);
						
			if(isset($item['ID'])) { 

				$content['group'] = $row['group'];
				$content['subject'] = $row['subject'];
				$response['final'][$item['ID']][] = $content;				
			}
			else	$response['final'][$row['group']][$row['subject']][] = $content;
		}					
	}
	
	$db -> commit();	
}

function read_freegroups($data) {
	
	global $response, $db, $name;
	$table = $name . "_round";
	
	$db -> beginTransaction();
	
	$query = "SELECT MAX(subject) FROM $table";
	$query = $db -> prepare($query);
	$query -> execute();
	$max_subject = $query -> fetch(PDO::FETCH_ASSOC);
		
	for($i = $data[0]; $i <= $data[1]; ++$i)  { 	$response['freegroups'][$i] = $i;		}
		
	if($max_subject['MAX(subject)'] != '') {
					
		$max_subject = $max_subject['MAX(subject)'];
			
		$query = "SELECT `group` FROM $table GROUP BY `group` HAVING SUM(initialized) >= $max_subject";
			
		$query = $db -> prepare($query);
		$query -> execute();
		
		while($row = $query -> fetch(PDO::FETCH_ASSOC)) {				
			unset($response['freegroups'][$row['group']]);
		}
	
	}
	
	$db -> commit();	
}

function get_parameters($ID) {
	
	global $response, $db, $name;
	$table = $name . "_round";
		
	$query = $db -> prepare("SELECT subject,`group`,team,stage,round,part FROM $table WHERE ID = :ID");
	$query -> execute(array(':ID' => $ID));
		
	$output = $query -> fetch(PDO::FETCH_ASSOC);
		
	return $output;	
}


try {
	
	$parameters = simplexml_load_file('../../content/global parameters.xml');
	$name = $parameters->name;
	
	include("database.php");
	$input = $_REQUEST['options'];
	
	if(isset($input['behavior']))  	{ read_behavior($input['behavior']); }
	if(isset($input['payoff']))    	{ read_payoff($input['payoff']); }
	if(isset($input['log'])) 	   	{ read_log($input['log']); }
	if(isset($input['final'])) 	   	{ read_final($input['final']); }
	if(isset($input['freegroups'])) { read_freegroups($input['freegroups']); }
	if(isset($input['status']))  	{ read_status($input['status']); }

	echo json_encode($response);
	$db = null;
}


catch(PDOException $e) {
	
	$response["error"] = $e -> getMessage();
	echo json_encode($response);
	exit;
}
catch(exception $e) {

	$response["error"] = $e -> getMessage();
	echo json_encode($response);
	exit;
}


?>