<?php

$response = array();

function wait($state, $waitfor) {
	
	global $response, $db, $name;
	$table = $name . "_round";
	
	$db -> beginTransaction();
		
	$query_string = "SELECT subject,part,stage,round FROM $table WHERE `group` = :group AND subject != :subject AND `initialized` = 1";
	$params = array("group" => $state['group'], "subject" => $state['subject']);
		
	if($waitfor == 'team') {
		
		$query_string = $query_string . " AND team = :team";	
		$params['team'] = $state['team'];
	}
		
	
	$query = $db -> prepare($query_string);		
	$query -> execute($params);
	
	$waiting = false;	
	while($row = $query -> fetch(PDO::FETCH_ASSOC)) {
		
		if($row['part'] < $state['part']) {
			$waiting = true;
			$response['waitingfor'][] = $row['subject'];			
		}
		else if($row['part'] == $state['part'] && $row['stage'] < $state['stage'] && $row['round'] == $state['round']) { 	
			$waiting = true;
			$response['waitingfor'][] = $row['subject'];
		}
		else if($row['part'] == $state['part'] && $row['round'] < $state['round']) { 	
			$waiting = true;	
			$response['waitingfor'][] = $row['subject'];
		}		

	}
	
	$db -> commit();
	$response['wait'] = $waiting;
		
}

function get_parameters($ID) {
	
	global $response, $db, $name;
	$table = $name . "_round";
		
	$query = $db -> prepare("SELECT subject,`group`,team,stage,round,part FROM $table WHERE ID = :ID");
	$query -> execute(array(':ID' => $ID));
		
	$output = $query -> fetch(PDO::FETCH_ASSOC);
		
	return $output;	
}


try {
	
	$parameters = simplexml_load_file('../../content/global parameters.xml');
	$name = $parameters->name;
						
	include("database.php");
	
	$ID = $_REQUEST['ID'];
	$waitfor = $_REQUEST['waitfor'];
	
	$state = get_parameters($ID);	
	wait($state, $waitfor);
	
	echo json_encode($response);
	$db = null;
}


catch(PDOException $e) {
	
	$response["error"] = $e -> getMessage();
	echo json_encode($response);
	exit;
}
catch(exception $e) {

	$response["error"] = $e -> getMessage();
	echo json_encode($response);
	exit;
}

?>
