<?php

$response = array();
$date = date('Y_m_d_G_i_s');


function add_behavior($data) {
	
	global $response, $date, $db, $name;
	$table = $name . "_behavior";
	
	$db -> beginTransaction();
	
	foreach($data as $key=>$item) {
		
		if(isset($item['ID'])) {
			
			$status = get_parameters($item['ID']);
			$item['subject'] = $status['subject'];
			$item['group']   = $status['group'];
			if(!isset($item['team']))   $item['team']  = $status['team'];
			if(!isset($item['stage']))  $item['stage'] = $status['stage'];
			if(!isset($item['round']))  $item['round'] = $status['round'];
			if(!isset($item['part']))   $item['part']  = $status['part'];
		}
		
		$content = array(
			":date"      => $date,
		    ":subject"   => $item['subject'],
		    ":group"     => $item['group'],
		    ":team"      => $item['team'],
			":stage"     => $item['stage'],
			":round"     => $item['round'],
			":part"      => $item['part'],
			":type"      => $item['type'],
			":treatment" => $item['treatment'],
			":response"  => $item['response'],
			":RT"        => $item['RT'],
			":comment"   => $item['comment']
		);
				
		$query = "INSERT INTO $table VALUES (DEFAULT, :date, :subject, :group, :team, :stage, :round, :part, :type, :treatment, :response, :RT, :comment)";
				
		$query = $db -> prepare($query);
		$query -> execute($content);
		
		if(!isset($item['subject']))	$response["warning"][] = __FUNCTION__ . '[' . strval($key+1) . ']: subject not set – set to NULL';
		if(!isset($item['group']))		$response["warning"][] = __FUNCTION__ . '[' . strval($key+1) . ']: group not set – set to NULL';
		if(!isset($item['team']))		$response["warning"][] = __FUNCTION__ . '[' . strval($key+1) . ']: team not set – set to NULL';
		if(!isset($item['stage']))		$response["warning"][] = __FUNCTION__ . '[' . strval($key+1) . ']: stage not set – set to NULL';
		if(!isset($item['round']))		$response["warning"][] = __FUNCTION__ . '[' . strval($key+1) . ']: round not set – set to NULL';
		if(!isset($item['part']))		$response["warning"][] = __FUNCTION__ . '[' . strval($key+1) . ']: part not set – set to NULL';
		if(!isset($item['type']))		$response["warning"][] = __FUNCTION__ . '[' . strval($key+1) . ']: type not set – set to NULL';
		if(!isset($item['treatment']))	$response["warning"][] = __FUNCTION__ . '[' . strval($key+1) . ']: treatment not set – set to NULL';
		if(!isset($item['response']))	$response["warning"][] = __FUNCTION__ . '[' . strval($key+1) . ']: response not set – set to NULL';
		if(!isset($item['RT']))			$response["warning"][] = __FUNCTION__ . '[' . strval($key+1) . ']: RT not set – set to NULL';
		if(!isset($item['comment']))	$response["warning"][] = __FUNCTION__ . '[' . strval($key+1) . ']: comment not set – set to NULL';		
	}
	
	$db -> commit();	
}

function add_payoff($data) {
	
	global $response, $date, $db, $name;
	$table = $name . "_payoff";
	
	$db -> beginTransaction();
	
	foreach($data as $key=>$item) {
		
		if(isset($item['ID'])) {
			
			$status = get_parameters($item['ID']);
			$item['subject'] = $status['subject'];
			$item['group']   = $status['group'];
			if(!isset($item['team']))   $item['team']  = $status['team'];
			if(!isset($item['stage']))  $item['stage'] = $status['stage'];
			if(!isset($item['round']))  $item['round'] = $status['round'];
			if(!isset($item['part']))   $item['part']  = $status['part'];
		}
		
		$content = array(
			":date"      => $date,
		    ":subject"   => $item['subject'],
		    ":group"     => $item['group'],
		    ":team"      => $item['team'],
			":stage"     => $item['stage'],
			":round"     => $item['round'],
			":part"      => $item['part'],
			":type"      => $item['type'],
			":treatment" => $item['treatment'],
			":payoff"    => $item['payoff'],
			":RT"        => $item['RT'],
			":comment"   => $item['comment']
		);
				
		$query = "INSERT INTO $table VALUES (DEFAULT, :date, :subject, :group, :team, :stage, :round, :part, :type, :treatment, :payoff, :RT, :comment)";
				
		$query = $db -> prepare($query);
		$query -> execute($content);
		
		if(!isset($item['subject']))	$response["warning"][] = __FUNCTION__ . '[' . strval($key+1) . ']: subject not set – set to NULL';
		if(!isset($item['group']))		$response["warning"][] = __FUNCTION__ . '[' . strval($key+1) . ']: group not set – set to NULL';
		if(!isset($item['team']))		$response["warning"][] = __FUNCTION__ . '[' . strval($key+1) . ']: team not set – set to NULL';
		if(!isset($item['stage']))		$response["warning"][] = __FUNCTION__ . '[' . strval($key+1) . ']: stage not set – set to NULL';
		if(!isset($item['round']))		$response["warning"][] = __FUNCTION__ . '[' . strval($key+1) . ']: round not set – set to NULL';
		if(!isset($item['part']))		$response["warning"][] = __FUNCTION__ . '[' . strval($key+1) . ']: part not set – set to NULL';
		if(!isset($item['type']))		$response["warning"][] = __FUNCTION__ . '[' . strval($key+1) . ']: type not set – set to NULL';
		if(!isset($item['treatment']))	$response["warning"][] = __FUNCTION__ . '[' . strval($key+1) . ']: treatment not set – set to NULL';
		if(!isset($item['payoff']))	    $response["warning"][] = __FUNCTION__ . '[' . strval($key+1) . ']: payoff not set – set to NULL';
		if(!isset($item['RT']))			$response["warning"][] = __FUNCTION__ . '[' . strval($key+1) . ']: RT not set – set to NULL';
		if(!isset($item['comment']))	$response["warning"][] = __FUNCTION__ . '[' . strval($key+1) . ']: comment not set – set to NULL';		
	}
	
	$db -> commit();
}

function add_log($data) {
	
	global $response, $date, $db, $name;
	$table = $name . "_log";
	
	$db -> beginTransaction();
	
	foreach($data as $key=>$item) {
		
		if(isset($item['ID'])) {
			
			$status = get_parameters($item['ID']);
			$item['subject'] = $status['subject'];
			$item['group']   = $status['group'];
			if(!isset($item['team']))   $item['team']  = $status['team'];
			if(!isset($item['stage']))  $item['stage'] = $status['stage'];
			if(!isset($item['round']))  $item['round'] = $status['round'];
			if(!isset($item['part']))   $item['part']  = $status['part'];
		}
		
		$content = array(
			":date"      => $date,
		    ":subject"   => $item['subject'],
		    ":group"     => $item['group'],
		    ":team"      => $item['team'],
			":stage"     => $item['stage'],
			":round"     => $item['round'],
			":part"      => $item['part'],
			":type"      => $item['type'],
			":treatment" => $item['treatment'],
			":log"       => $item['log'],
			":RT"        => $item['RT'],
			":comment"   => $item['comment']
		);
				
		$query = "INSERT INTO $table VALUES (DEFAULT, :date, :subject, :group, :team, :stage, :round, :part, :type, :treatment, :log, :RT, :comment)";
				
		$query = $db -> prepare($query);
		$query -> execute($content);
		
		if(!isset($item['subject']))	$response["warning"][] = __FUNCTION__ . '[' . strval($key+1) . ']: subject not set – set to NULL';
		if(!isset($item['group']))		$response["warning"][] = __FUNCTION__ . '[' . strval($key+1) . ']: group not set – set to NULL';
		if(!isset($item['team']))		$response["warning"][] = __FUNCTION__ . '[' . strval($key+1) . ']: team not set – set to NULL';
		if(!isset($item['stage']))		$response["warning"][] = __FUNCTION__ . '[' . strval($key+1) . ']: stage not set – set to NULL';
		if(!isset($item['round']))		$response["warning"][] = __FUNCTION__ . '[' . strval($key+1) . ']: round not set – set to NULL';
		if(!isset($item['part']))		$response["warning"][] = __FUNCTION__ . '[' . strval($key+1) . ']: part not set – set to NULL';
		if(!isset($item['type']))		$response["warning"][] = __FUNCTION__ . '[' . strval($key+1) . ']: type not set – set to NULL';
		if(!isset($item['treatment']))	$response["warning"][] = __FUNCTION__ . '[' . strval($key+1) . ']: treatment not set – set to NULL';
		if(!isset($item['log']))	    $response["warning"][] = __FUNCTION__ . '[' . strval($key+1) . ']: log not set – set to NULL';
		if(!isset($item['RT']))			$response["warning"][] = __FUNCTION__ . '[' . strval($key+1) . ']: RT not set – set to NULL';
		if(!isset($item['comment']))	$response["warning"][] = __FUNCTION__ . '[' . strval($key+1) . ']: comment not set – set to NULL';		
	}
	
	$db -> commit();
}

function add_final($data) {
	
	global $response, $date, $db, $name;
	$table = $name . "_final";
	
	$db -> beginTransaction();
		
	foreach($data as $key=>$item) {
		
		if(isset($item['ID'])) {
			
			$status = get_parameters($item['ID']);
			$item['subject'] = $status['subject'];
			$item['group']   = $status['group'];
			if(!isset($item['team']))   $item['team']  = $status['team'];
			if(!isset($item['stage']))  $item['stage'] = $status['stage'];
			if(!isset($item['round']))  $item['round'] = $status['round'];
			if(!isset($item['part']))   $item['part']  = $status['part'];
		}
		
		$content = array(
			":date"      => $date,
		    ":subject"   => $item['subject'],
		    ":group"     => $item['group'],
		    ":team"      => $item['team'],
			":stage"     => $item['stage'],
			":round"     => $item['round'],
			":part"      => $item['part'],
			":type"      => $item['type'],
			":treatment" => $item['treatment'],
			":final"     => $item['final'],
			":RT"        => $item['RT'],
			":comment"   => $item['comment']
		);
				
		$query = "INSERT INTO $table VALUES (DEFAULT, :date, :subject, :group, :team, :stage, :round, :part, :type, :treatment, :final, :RT, :comment)";
				
		$query = $db -> prepare($query);
		$query -> execute($content);
		
		if(!isset($item['subject']))	$response["warning"][] = __FUNCTION__ . '[' . strval($key+1) . ']: subject not set – set to NULL';
		if(!isset($item['group']))		$response["warning"][] = __FUNCTION__ . '[' . strval($key+1) . ']: group not set – set to NULL';
		if(!isset($item['team']))		$response["warning"][] = __FUNCTION__ . '[' . strval($key+1) . ']: team not set – set to NULL';
		if(!isset($item['stage']))		$response["warning"][] = __FUNCTION__ . '[' . strval($key+1) . ']: stage not set – set to NULL';
		if(!isset($item['round']))		$response["warning"][] = __FUNCTION__ . '[' . strval($key+1) . ']: round not set – set to NULL';
		if(!isset($item['part']))		$response["warning"][] = __FUNCTION__ . '[' . strval($key+1) . ']: part not set – set to NULL';
		if(!isset($item['type']))		$response["warning"][] = __FUNCTION__ . '[' . strval($key+1) . ']: type not set – set to NULL';
		if(!isset($item['treatment']))	$response["warning"][] = __FUNCTION__ . '[' . strval($key+1) . ']: treatment not set – set to NULL';
		if(!isset($item['final']))	    $response["warning"][] = __FUNCTION__ . '[' . strval($key+1) . ']: final not set – set to NULL';
		if(!isset($item['RT']))			$response["warning"][] = __FUNCTION__ . '[' . strval($key+1) . ']: RT not set – set to NULL';
		if(!isset($item['comment']))	$response["warning"][] = __FUNCTION__ . '[' . strval($key+1) . ']: comment not set – set to NULL';		
	}
	
	$db -> commit();
}

function increment($data) {
	
	global $response, $db, $name, $parameters;
	$table = $name . "_round";
	
	$db -> beginTransaction();
	
	foreach($data as $key=>$item) {
		
		if(isset($item['ID'])) {
			
			$status = get_parameters($item['ID']);
			$item['subject'] = $status['subject'];
			$item['group']   = $status['group'];
		}
		
		$query = $db -> prepare("SELECT stage,round,part FROM $table WHERE `group` = :group AND subject = :subject");
		$query -> execute(array(':group' =>  $item['group'], ':subject' =>  $item['subject']));
		$row = $query -> fetch(PDO::FETCH_ASSOC);
				
		if($item['onlypart'] == 'true') {
			
			$query = $db -> prepare("UPDATE $table SET `part` = :part, round = 1, stage = 1 WHERE `group` = :group AND subject = :subject");
			$query -> execute(array(':part' => $row['part'] + 1, ':group' =>  $item['group'], ':subject' =>  $item['subject']));				
		}
		else {
			
			if($row['stage'] + 1 > $item['stages']) {	$row['round']++; $row['stage'] = 1; }
			#if($row['stage'] + 1 > $parameters->stages) {	$row['round']++; $row['stage'] = 1; }
			else {	$row['stage']++;  }
			
			$query = $db -> prepare("UPDATE $table SET round = :round, stage = :stage WHERE `group` = :group AND subject = :subject");
			$query -> execute(array(':round' => $row['round'], ':stage' => $row['stage'], ':group' =>  $item['group'], ':subject' =>  $item['subject']));								
		}
		
		if($row['round'] > $item['rounds']) {  $response["finished"][$item['group']] = $item['subject'];  }	
		#if($row['round'] > $parameters->rounds) {  $response["finished"][$item['group']] = $item['subject'];  }	
	}
	
	$db -> commit();
}

function export_parameters($data) {
	
	global $response;
	
	if(isset($data['ID'])) {
	
		$ID = $data['ID']; 
		unset($data['ID']);
	
		$xml = new SimpleXMLElement('<parameters></parameters>');
		array_to_xml($data, $xml);
		
		$dom = new DOMDocument('1.0');
	  	$dom->preserveWhiteSpace = false;
	  	$dom->formatOutput = true;
	  	$dom->loadXML($xml->asXML());
		
		$dom -> save("../../content/local parameters $ID.xml");
 
	  	//return $dom->saveXML();
		//$result = $xml -> asXML("../../content/local parameters $ID.xml");
				
	} 
	else {
		
		$response["warning"][] = __FUNCTION__ . ': ID not set - export of parameters failed';
		
	}	
}

function get_parameters($ID) {
	
	global $response, $db, $name;
	$table = $name . "_round";
		
	$query = $db -> prepare("SELECT subject,`group`,team,stage,round,part FROM $table WHERE ID = :ID");
	$query -> execute(array(':ID' => $ID));
		
	$output = $query -> fetch(PDO::FETCH_ASSOC);
		
	return $output;	
}


//function array_to_xml($data, &$xml_data) {
//    foreach( $data as $key => $value ) {
//        if( is_array($value) ) {
//            if( is_numeric($key) ){
//                $key = 'item'.$key; //dealing with <0/>..<n/> issues
//            }
//            $subnode = $xml_data->addChild($key);
//            array_to_xml($value, $subnode);
//        } else {
//            $xml_data->addChild("$key",htmlspecialchars("$value"));
//        }
//     }
//}

//function array_to_xml($array, &$xml)
//{
//
//    foreach($array as $key => $value)
//    {
//        if(is_array($value))
//        {
//            foreach($value as $subvalue)
//            {
//                $xml->addChild("$key","$subvalue");
//            }
//        } 
//    else 
//        {            
//            $xml->addChild("$key","$value");
//        }
//    }
//}


//function array_to_xml( $data, &$xml ) {
//	
//	
//    foreach( $data as $key => $value ) {
//        
//		//if( is_numeric($key) ){
//        //    $key = 'item'.$key; //dealing with <0/>..<n/> issues
//		//	$xml->addChild("$key","$value");	
//        //}
//		
//		if(is_array($value) && !is_numeric($key)) {
//			
//			$subnode = $xml->addChild($key);
//			array_to_xml($value, $subnode);
//		}
//        else if(is_numeric($key) ) {
//			
//            foreach($value as $subvalue)
//            {
//                $xml->addChild("$key","$subvalue");
//            }
//			
//			//$subnode = $xml->addChild($key);
//			//array_to_xml($value, $subnode);
//        } 
//		else {
//			$xml->addChild("$key",htmlspecialchars("$value"));
//        }
//		
//     }
//}


function array_to_xml($data, &$xml) {
	
	foreach($data as $key => $value) {
    
		if(is_array($value)) {
		
			if(count(array_filter(array_keys($value), 'is_string')) == 0) {
			
				foreach($value as $subvalue) {
					$xml->addChild("$key","$subvalue");	
	            }
			}
			else {
				
				$subnode = $xml->addChild($key);
				array_to_xml($value, $subnode);
			}	
        } 
		else {
			
			$xml->addChild("$key",htmlspecialchars("$value"));
		}
	}
}




try {
	
	$parameters = simplexml_load_file('../../content/global parameters.xml');
	$name = $parameters->name;
	
	include("database.php");
	$input = $_REQUEST['options'];
	
		
	if(isset($input['behavior']))  { add_behavior($input['behavior']); }
	if(isset($input['payoff']))    { add_payoff($input['payoff']); }
	if(isset($input['log'])) 	   { add_log($input['log']); }
	if(isset($input['final'])) 	   { add_final($input['final']); }
	
	if(isset($input['increment'])) { increment($input['increment']); }
	if(isset($input['parameters'])) { export_parameters($input['parameters']); }
	

	echo json_encode($response);
	$db = null;
}


catch(PDOException $e) {
	
	$response["error"] = $e -> getMessage();
	echo json_encode($response);
	exit;
}
catch(exception $e) {

	$response["error"] = $e -> getMessage();
	echo json_encode($response);
	exit;
}


?>